#include "GenerateurUnique.h"
#include "GenerateurStochastique.h"
#include "SingletonDefinition.h"
#include <algorithm>
using namespace std;

bool GenerateurUnique::contient(value_type val) const
   { return find(begin(distribue), end(distribue), val) != end(distribue); }


auto GenerateurUnique::prochain() -> value_type
{
   auto val = singletons::get().get_singleton<GenerateurStochastique>().prochain();
   while (contient(val)) // Boucle: O(???)
      val = singletons::get().get_singleton<GenerateurStochastique>().prochain();
   distribue.push_back(val);
   return val;
}

void GenerateurUnique::remettre(value_type val)
{
   if (!contient(val)) throw ValeurIncoherente{};
   remove(begin(distribue), end(distribue), val);
   // ICI: au besoin, insrer une compression conditionnelle de distribue_
   // (le code actuel est simple mais abusif)
   distribue.shrink_to_fit();
}
