#ifndef GENERATEUR_UNIQUE_H
#define GENERATEUR_UNIQUE_H

#include <vector>
#include "Intervalle.h"
#include "SingletonContextFwd.h"
#include "Incopiable.h"

class GenerateurUnique
   : Incopiable
{
public:
   using value_type = int;
private:
   std::vector<value_type> distribue;
   GenerateurUnique() = default;
   bool contient(value_type) const;
   friend struct SingletonWrapper<GenerateurUnique>;
public:
   value_type prochain();
   void remettre(value_type);
};

#endif
