#ifndef GENERATEURSTOCHASTIQUE_H
#define GENERATEURSTOCHASTIQUE_H

#include "Intervalle.h"
#include "SingletonContextFwd.h"
#include "Incopiable.h"
#include <random>

class GenerateurStochastique
   : Incopiable
{
public:
   using value_type = int;
private:
   mutable std::mt19937 prng;
   GenerateurStochastique();
   friend struct SingletonWrapper<GenerateurStochastique>;
public:
   // bornes inclusives
   value_type prochain(const Intervalle<value_type> & = {}) const;
};

#endif
